
/**************************************************************************************************************************

						P H O T O F L A S H -- I M  A G E   M A N I P U L A T O R

**************************************************************************************************************************/

import java.io.*;
import java.io.File.*;
import java.io.FileFilter;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.color.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.net.*;
import java.lang.*;
import com.sun.image.codec.jpeg.*;


class MenuObject extends JFrame implements ActionListener
{
	int zoom=20;

	boolean flip=false;
	boolean orig=false;

	JMenu Menu;
	JFileChooser fc;
	JMenuBar MenuBar;
	JMenuItem MenuItem;
	JMenuItem grayButton;
	JDialog dialog,shdialog;
	JMenuItem tileItem,imgSrcItem;
	JSlider slider1,slider2,slider3,slider4,slider;
	JMenuItem sharpenButton, blurringButton,edButton;
	JComboBox scaleXval,scaleYval,shearXval,shearYval;
	JMenuItem newItem,openItem,saveItem,closeItem,exitItem;
	JMenuItem incBrightItem,decBrightItem,incContrastItem,decContrastItem,negItem;
	JMenuItem redBandButton,greenBandButton,blueBandButton,inverseBandButton,middleBandButton,BresetBandButton,aboutItem;
	

	FileDialog fileDialog;

	String[] shearValues={"0.00","0.25","0.50","0.75","1.00"};
	String[] scaleValues={"0.10","0.25","0.50","0.75","1.00","1.25","1.5","1.75","2.00"};


	DisplayPanel pobj = new DisplayPanel();

	public MenuObject()
	{
                super(" An Image Processing project in Java - by Ravi & Mustazab");

		fc=new JFileChooser();
		JPanel contentPane = new JPanel();
		JScrollPane scroller = new JScrollPane(pobj,ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

		addMenuButtons();
		contentPane.setLayout(new BorderLayout());
		setContentPane(contentPane);

     	getContentPane().add(scroller, BorderLayout.CENTER);
		pobj.setPreferredSize(new Dimension(pobj.displayImage.getWidth(this),pobj.displayImage.getWidth(this)));
		pobj.revalidate();
	}

	public void actionPerformed(ActionEvent e)
	{
		JMenuItem button=(JMenuItem)e.getSource();

		if(button.equals(exitItem))
		{
				System.exit(0);
		}

		if(button.equals(imgSrcItem))
		{
			pobj.init();
			pobj.repaint();
		}

		if(button.equals(tileItem))
		{
			pobj.tileInit();
			pobj.repaint();
		}

		if(button.equals(saveItem))
		{
			int returnVal = fc.showSaveDialog(MenuObject.this);
	 		if (returnVal == JFileChooser.APPROVE_OPTION)
	 		{
       			File file = fc.getSelectedFile();
  				String str=file.getAbsolutePath();
  				pobj.save(str);
   				repaint();
   			}
		}

		if(button.equals(openItem))
		{
			int returnVal = fc.showOpenDialog(MenuObject.this);
	 		if (returnVal == JFileChooser.APPROVE_OPTION)
	 		{
       			File file = fc.getSelectedFile();
  				String str=file.getAbsolutePath();
  				URL	 url; 
   				try
       			{
       				url=file.toURL();
      				pobj.loadImage(url);
       			}
       			catch(Exception e1)
       			{
       				System.out.print("Error");
       			}
   			}
		}
		
		if(button.equals(aboutItem))
		{
			ImageIcon icon = new ImageIcon("arv_mac.jpg");
                    JOptionPane.showMessageDialog(null,"   Image Manipulator Designed By \n\n"+
                                     "        H.S.Ravi    \n"+
                                     "                And      Mustazab    \n"  ,                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
       "About ",JOptionPane.PLAIN_MESSAGE,icon);
		}
	}

	public void initDialog()
	{
		dialog=new JDialog(this,"Perform Affine transformation",true);
		Container container=dialog.getContentPane();
		dialog.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		dialog.addWindowListener(new WindowAdapter()
										{
        	   								public void windowClosing(WindowEvent we) {}
        					            }
        					     );
     	JPanel dialogPane=new JPanel();
     	dialogPane.setLayout(new GridLayout(1,3));
     	dialogPane.setBorder(new TitledBorder("Control Panel"));
     	container.add(dialogPane,BorderLayout.NORTH);
     	JLabel label1=new JLabel("Scale (sx,sy)");
     	JLabel label2=new JLabel("Shear (shx,shy)");
		dialogPane.add(label1);
		setSlider(dialogPane,JSlider.HORIZONTAL,0,200,100,25,5);
		slider1=slider;
		setSlider(dialogPane,JSlider.HORIZONTAL,0,200,100,25,5);
		slider2=slider;
		dialog.setContentPane(dialogPane);
		dialog.pack();
	}

	public void shinitDialog()
	{
		shdialog=new JDialog(this,"Perform Affine transformation",true);
		Container container=shdialog.getContentPane();
		shdialog.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		shdialog.addWindowListener(new WindowAdapter()
										{
        					                public void windowClosing(WindowEvent we){}
        					             }
        					      );
     	JPanel dialogPane=new JPanel();
     	dialogPane.setLayout(new GridLayout(1,3));
     	dialogPane.setBorder(new TitledBorder("Control Panel"));
     	container.add(dialogPane,BorderLayout.NORTH);
     	JLabel label2=new JLabel("Shear (shx,shy)");
     	dialogPane.add(label2);
     	setSlider(dialogPane,JSlider.HORIZONTAL,0,100,0,25,5);
     	slider3=slider;
     	setSlider(dialogPane,JSlider.HORIZONTAL,0,100,0,25,5);
     	slider4=slider;
     	shdialog.setContentPane(dialogPane);
     	shdialog.pack();
	}

	void setSlider(JPanel panel,int orientation,int minimumValue,int maximumValue,int initValue,int majorTickSpacing,int minorTickSpacing)
	{
		slider=new JSlider(orientation,minimumValue,maximumValue,initValue);
		slider.setPaintTicks(true);
		slider.setMajorTickSpacing(majorTickSpacing);
		slider.setMinorTickSpacing(minorTickSpacing);
		slider.setPaintLabels(true);
		slider.addChangeListener(new SliderListener());
		panel.add(slider);
	}
	class SliderListener implements ChangeListener
	{
		public void stateChanged(ChangeEvent e)
		{
			JSlider tempSlider=(JSlider) e.getSource();

			if(tempSlider.equals(slider1))
			{
				pobj.scalex=(double)slider1.getValue()/100.0;
				pobj.applyValue(true,false);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(tempSlider.equals(slider2))
			{
				pobj.scaley=(double)slider2.getValue()/100.0;
				pobj.applyValue(true,false);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(tempSlider.equals(slider3))
			{
				pobj.shearx=(double)slider3.getValue()/100.0;
				pobj.applyValue(false,true);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(tempSlider.equals(slider4))
			{
				pobj.sheary=(double)slider4.getValue()/100.0;
				pobj.applyValue(false,true);
				pobj.affineApplyFilter();
				pobj.repaint();
			}
	   	}
	}


	class AffineListener implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			dialog.show();
		}
	}


	class ComboBoxListener implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			JComboBox temp=(JComboBox) e.getSource();

			if(temp==scaleXval)
			{
				pobj.scalex=Double.parseDouble((String) temp.getSelectedItem());
				pobj.applyValue(true,false);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(temp==scaleYval)
			{
				pobj.scaley=Double.parseDouble((String) temp.getSelectedItem());
				pobj.applyValue(true,false);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(temp==shearXval)
			{
				pobj.shearx=Double.parseDouble((String) temp.getSelectedItem());
				pobj.applyValue(false,true);
				pobj.affineApplyFilter();
				pobj.repaint();
			}

			if(temp==shearYval)
			{
				pobj.sheary=Double.parseDouble((String) temp.getSelectedItem());
				pobj.applyValue(false,true);
				pobj.affineApplyFilter();
				pobj.repaint();
			}
		}
	}


	class BandListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			JMenuItem button = (JMenuItem)e.getSource();
			if(button.equals(redBandButton))
			{
				flip=true;
				pobj.bandCombine(pobj.RED_BAND_MATRIX);
				pobj.repaint();
			}
			else
				if(button.equals(greenBandButton))
				{
					flip=true;
					pobj.bandCombine(pobj.GREEN_BAND_MATRIX);
					pobj.repaint();
				}

				else
					if(button.equals(blueBandButton))
					{
						flip=true;
						pobj.bandCombine(pobj.BLUE_BAND_MATRIX);
						pobj.repaint();
					}
					else
						if(button.equals(inverseBandButton))
						{
							flip=true;
							pobj.bandCombine(pobj.INVERSE_BAND_MATRIX);
							pobj.repaint();
						}
						else
							if(button.equals(middleBandButton))
							{
								flip=true;
								pobj.bandCombine(pobj.AVERAGE_BAND_MATRIX);
								pobj.repaint();
							}
							else
								if (button.equals(BresetBandButton))
								{
									pobj.Creset();
									pobj.repaint();
								}
		}
	}


	class ConvolutionListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			JMenuItem menuItem = (JMenuItem) e.getSource();

			if(menuItem.equals(sharpenButton))
			{
				flip=true;
				pobj.sharpen();
				pobj.repaint();
			}
			else
				if(menuItem.equals(blurringButton))
				{
					flip=true;
					pobj.blur();
					pobj.repaint();
				}
				else
					if(menuItem.equals(edButton))
					{
						flip=true;
						pobj.edgeDetect();
						pobj.repaint();
					}
		}
	}


	class ColorConvListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			JMenuItem menuItem=(JMenuItem)e.getSource();
			if(menuItem.equals(grayButton))
			{
				flip=false;
				pobj.grayOut();
				pobj.repaint();
			}
		}
	}


	class LookupListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			JMenuItem menuItem=(JMenuItem)e.getSource();
			if(menuItem.equals(incBrightItem))
			{
				flip=false;
				pobj.brightenLUT();
				pobj.applyFilter();
				pobj.repaint();
			}
			else
				if(menuItem.equals(decBrightItem))
				{
					flip=false;
					pobj.darkenLUT();
					pobj.applyFilter();
					pobj.repaint();
				}
				else
					if(menuItem.equals(incContrastItem))
					{
						flip=false;
						pobj.contrastIncLUT();
						pobj.applyFilter();
						pobj.repaint();
					}
					else
						if(menuItem.equals(decContrastItem))
						{
							flip=false;
							pobj.contrastDecLUT();
							pobj.applyFilter();
							pobj.repaint();
						}
						else
							if(menuItem.equals(negItem))
							{
								flip=false;
								pobj.reverseLUT();
								pobj.applyFilter();
								pobj.repaint();
							}
		}
	}


	class ReloadListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			pobj.undoFlip();
		}
	}


	class FlipActionListener implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			pobj.flipBufferedImage();
			flip=true;

		}
	}


	void addMenuButtons()
	{
		MenuBar=new JMenuBar();

		Menu=new JMenu("File");
		setJMenuBar(MenuBar);
		MenuBar.add(Menu);

		openItem=new JMenuItem("Open");
		openItem.addActionListener(this);
		Menu.add(openItem);

		saveItem=new JMenuItem("Save");
		saveItem.addActionListener(this);
    	Menu.add(saveItem);

		exitItem=new JMenuItem("Exit");
		Menu.add(exitItem);
		exitItem.addActionListener(this);

		Menu=new JMenu("Zoom");
		MenuBar.add(Menu);

		JMenuItem button=new JMenuItem("Zoom>>");
  		button.addActionListener(new ActionListener()
  									 {
										 public void actionPerformed (ActionEvent e)
										 {
										 	pobj.Zoom();
											pobj.repaint();
										 }
									  }
								);
    	Menu.add(button);
	    button=new JMenuItem("Zoom<<");
  		button.addActionListener(new ActionListener()
  									{
  										public void actionPerformed (ActionEvent e)
  										{
  											pobj.redZoom();
											pobj.repaint();
										}
    								}
    							);
    	Menu.add(button);
		Menu=new JMenu("FlipOp");
		MenuBar.add (Menu);
		MenuItem =new JMenuItem("Flip");
		Menu.add(MenuItem);
		MenuItem.addActionListener(new FlipActionListener());


		Menu=new JMenu("ChangeFeatures");
		MenuBar.add(Menu);
		MenuItem.addActionListener(new LookupListener());

		incBrightItem=new JMenuItem("Brightness >>");
		Menu.add(incBrightItem);
		incBrightItem.addActionListener(new LookupListener());

		decBrightItem=new JMenuItem("Brightness <<");
		decBrightItem.addActionListener(new LookupListener());
		Menu.add(decBrightItem);

		incContrastItem=new JMenuItem("Contrast >>");
		Menu.add(incContrastItem);
		incContrastItem.addActionListener(new LookupListener());

		decContrastItem=new JMenuItem("Contrast <<");
		Menu.add(decContrastItem);
		decContrastItem.addActionListener(new LookupListener());

		negItem=new JMenuItem("Negative");
		Menu.add(negItem);
		negItem.addActionListener(new LookupListener());

		Menu=new JMenu("Scale/Shear");
		MenuBar.add(Menu);

		button=new JMenuItem("Scale");
        button.addActionListener(new ActionListener()
        							{
        								public void actionPerformed(ActionEvent e)
        								{
        							    	flip=true;
              								initDialog();
								            dialog.show();
							            }
							        }
							    );
	  	Menu.add(button);
      	button=new JMenuItem("Shear");
      	button.addActionListener(new ActionListener()
      									{
      									    public void actionPerformed(ActionEvent e)
      									    {
      									      	flip=true;
      	     									shinitDialog();
								           		shdialog.show();
								            }
								        }
								  );
	    Menu.add(button);

		Menu=new JMenu("ConvColor");
		MenuBar.add(Menu);

		grayButton=new JMenuItem("Gray Scale");
		Menu.add(grayButton);
		grayButton.addActionListener(new ColorConvListener());
		Menu=new JMenu("Convolute");
		MenuBar.add(Menu);

		sharpenButton=new JMenuItem("Sharpen");
		Menu.add(sharpenButton);
		sharpenButton.addActionListener(new ConvolutionListener());

		blurringButton=new JMenuItem("Blur");
		Menu.add(blurringButton);
		blurringButton.addActionListener(new ConvolutionListener());

		edButton=new JMenuItem("EdgeDetect");
		Menu.add(edButton);
		edButton.addActionListener(new ConvolutionListener());

		Menu=new JMenu("ShowBand");
		MenuBar.add(Menu);

		redBandButton=new JMenuItem("ShowRed");
		Menu.add(redBandButton);
		redBandButton.addActionListener(new BandListener());

		greenBandButton=new JMenuItem("ShowGreen");
		Menu.add(greenBandButton);
		greenBandButton.addActionListener(new BandListener());

		blueBandButton=new JMenuItem("ShowBlue");
		Menu.add(blueBandButton);
		blueBandButton.addActionListener(new BandListener());

		inverseBandButton=new JMenuItem("InvertAll");
		Menu.add(inverseBandButton);
		inverseBandButton.addActionListener(new BandListener());

		middleBandButton=new JMenuItem("AvgEach");
		Menu.add(middleBandButton);
		middleBandButton.addActionListener(new BandListener());

		BresetBandButton=new JMenuItem("Reset");
		Menu.add(BresetBandButton);
		BresetBandButton.addActionListener(new BandListener());
		
		Menu=new JMenu("About");
		MenuBar.add(Menu);
		
		aboutItem=new JMenuItem("About");
		Menu.add(aboutItem);
		aboutItem.addActionListener(this);

	}
}

class Example
{
	public Example()
	{
		MenuObject menuObj=new MenuObject();
		menuObj.addWindowListener(new WindowAdapter()
									  	{
											public void windowClosing(WindowEvent e)
											{
												System.exit(0);
											}
										}
								 );
		menuObj.pack();
		menuObj.setVisible(true);
	}

	public static void main(String args[])
	{
			Example exampleObj=new Example();
	}
}


class ImageFilter
{
    final static String jpeg = "jpeg";
    final static String jpg = "jpg";
    final static String gif = "gif";

    public boolean accept(File f)
    {

        if (f.isDirectory())
        	return true;

        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1)
        {
            String extension = s.substring(i+1).toLowerCase();
            if (gif.equals(extension) || jpeg.equals(extension) || jpg.equals(extension))
            {
                    return true;
            }
            else
            {
                return false;
            }
        }
        return false;
    }

    public String getDescription()
    {
        return "*.jpg,*.jpeg,*.gif";
    }
}


class DisplayPanel extends JPanel implements Scrollable
{

	int zoom=0;
	BufferedImage bi,bi1,bi2,bi3,biSrc,biDest,biOrig;
	public Image displayImage ;
	MediaTracker mt;
	static String filesavingimagename = "ULTIMATE.jpg";

	Graphics2D big;

	LookupTable LUT;


	public	static final float RED_BAND_MATRIX[][]=
													{
														{1.0f,0.0f,0.0f},
														{0.0f,0.0f,0.0f},
														{0.0f,0.0f,0.0f}
													};
	public static final float GREEN_BAND_MATRIX[][]=
													{
														{0.0f,0.0f,0.0f},
														{0.0f,1.0f,0.0f},
														{0.0f,0.0f,0.0f}
													};
	public	static final float BLUE_BAND_MATRIX[][]=
													{
														{0.0f,0.0f,0.0f},
														{0.0f,0.0f,0.0f},
														{0.0f,0.0f,1.0f}
													};

	public static final float INVERSE_BAND_MATRIX[][]=
													{
														{-1.0f,0.0f,0.0f},
														{0.0f,-1.0f,0.0f},
														{0.0f,0.0f,-1.0f}
													};
	public static final float AVERAGE_BAND_MATRIX[][]=
													{
														{0.5f,0.0f,0.0f},
														{0.0f,0.5f,0.0f},
														{0.0f,0.0f,0.5f}
													};
	Raster srcRaster;
	WritableRaster dstRaster;
	Image cell[];
	int iw,ih,tw,th;
	AffineTransform transform;
	public double scalex=1.0,scaley=1.0,shearx=1.0,sheary=1.0;
	boolean buffered=true;
	private int maxUnitIncrement = 1;

	public DisplayPanel()
	{
		super();
		zoom=0;
		displayImage=Toolkit.getDefaultToolkit().getImage("10.jpg");
		mt=new MediaTracker(this);
		mt.addImage(displayImage,1);

		try
		{
			mt.waitForAll();
		}
		catch(Exception e)
		{
			System.out.println("Exception while loading");
		}

		if(displayImage.getWidth(this)==-1)
		{
			 System.out.println(" *** Make sure u have the .jpeg file in the same directory");
			 System.exit(0);
		}
		iw=displayImage.getWidth(null);
		ih=displayImage.getHeight(null);
		tw=iw/4;
		th=ih/4;
		setBackground(Color.white);

		bi1=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		big=bi1.createGraphics();

		big.drawImage(displayImage,0,0,this);
		bi=bi1;
		biSrc=bi1;
		biDest=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		biOrig=bi;
		srcRaster=biSrc.getRaster();
		dstRaster=(WritableRaster)biDest.getRaster();
		buffered=true;
		transform = new AffineTransform();
	}

	public void loadImage(URL url)
	{

		displayImage=Toolkit.getDefaultToolkit().getImage(url);
		zoom=0;
		mt.addImage(displayImage,1);
		try
		{
			mt.waitForAll();
		}
		catch(Exception e)
		{
			System.out.println("Exception while loading");
		}
		if(displayImage.getWidth(this)==-1)
		{
			 System.out.println(" *** Make sure u have the .jpeg file in the same directory");
			 System.exit(0);
		}

		bi1=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		big=bi1.createGraphics();
		big.drawImage(displayImage,0,0,this);
		bi=bi1;
		biSrc=bi1;
		biDest=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		srcRaster=biSrc.getRaster();
		dstRaster=(WritableRaster)biDest.getRaster();
		biOrig=bi;
		buffered=true;
		iw=displayImage.getWidth(null);
		ih=displayImage.getHeight(null);
		tw=iw/4;
		th=ih/4;
		repaint();
	}

	public void redZoom()
	{
		if(zoom-20>=0)
			 zoom-=20;
	}

	public void update(Graphics g)
	{

		g.clearRect(0,0,getWidth()+zoom,getHeight()+zoom);
		paintComponent(g);
	}

	void save(String filetobesaved)
	{
		filesavingimagename = filetobesaved+".jpg";
	}

	public void updateimagetosave(String filenamestring,BufferedImage buffi)
	{
		try
		{
			File file = new File(filesavingimagename);
			FileOutputStream out  = new FileOutputStream(file);
			JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
			JPEGEncodeParam  param   = encoder.getDefaultJPEGEncodeParam(buffi);
			param.setQuality(1.0f, false);
			encoder.setJPEGEncodeParam(param);
			encoder.encode(buffi);
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}

	public void paintComponent(Graphics g)
	{
		if(!filesavingimagename.equals("1.jpg"))
		{
			updateimagetosave(filesavingimagename,bi);
			filesavingimagename = "1.jpg";
		}

		super.paintComponent(g);
		setPreferredSize(new Dimension(displayImage.getWidth(this)+zoom,displayImage.getHeight(this)+zoom));
		revalidate();
		Graphics2D g2D=(Graphics2D) g;

		if(buffered)
		{
				g2D.drawImage(bi,0,0,displayImage.getWidth(this)+zoom,displayImage.getHeight(this)+zoom,this);
		}
		else
		{
			for(int y=0;y<4;y++)
			{
				for(int x=0;x<4;x++)
				{
					g2D.drawImage(cell[y*4+x],x*tw,y*th,null);
				}
			}
		}
	}

	public Dimension getPreferredScrollableViewportSize()
	{
		return getPreferredSize();
	}

	public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction)
	{
		int currentPosition = 0;
		if (orientation == SwingConstants.HORIZONTAL)
			currentPosition = visibleRect.x;
		else
			currentPosition = visibleRect.y;

	    if (direction < 0)
	    {
			int newPosition = currentPosition - (currentPosition / maxUnitIncrement) * maxUnitIncrement;
			return (newPosition == 0) ? maxUnitIncrement : newPosition;
	    }
	    else
	    {
			return ((currentPosition / maxUnitIncrement) + 1) * maxUnitIncrement - currentPosition;
		}
	}

	public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction)
	{
		if (orientation == SwingConstants.HORIZONTAL)
			return visibleRect.width - maxUnitIncrement;
		else
			return visibleRect.height - maxUnitIncrement;
	}

	public boolean getScrollableTracksViewportWidth()
	{
		return false;
	}

	public boolean getScrollableTracksViewportHeight()
	{
		return false;
	}

	public void setMaxUnitIncrement(int pixels)
	{
		maxUnitIncrement = pixels;
	}

	public void undoFlip()
	{
		bi=bi3;
		repaint();
	}

	public void flipBufferedImage()
	{
		bi2=new BufferedImage(bi.getWidth(),bi.getHeight(),bi.getType());
		DataBuffer db1=bi.getRaster().getDataBuffer();
		DataBuffer db2=bi2.getRaster().getDataBuffer();

		for(int i=db1.getSize()-1,j=0;i>=0;--i,j++)
		{
			db2.setElem(j,db1.getElem(i));
		}

		bi3=bi;
		bi=bi2;
		repaint();
	}

	public void Zoom()
	{
		 zoom+=20;
	}

	public void brightenLUT()
	{
		short brighten[]=new short[256];
		for(int i=0;i<256;i++)
		{
			short pixelvalue=(short)(i+10);
			if(pixelvalue>255)
				pixelvalue=255;
			else
				if(pixelvalue<0)
					pixelvalue=0;
			brighten[i]=pixelvalue;
		}

		LUT=new ShortLookupTable(0,brighten);
	}

	public void darkenLUT()
	{
		short brighten[]=new short[256];
		for(int i=0;i<256;i++)
		{
			short pixelvalue=(short)(i-10);
			if(pixelvalue>255)
				pixelvalue=255;
			else
				if(pixelvalue<0)
					pixelvalue=0;
			brighten[i]=pixelvalue;
		}
		LUT=new ShortLookupTable(0,brighten);
	}

	public void contrastIncLUT()
	{
		short brighten[]=new short[256];
		for(int i=0;i<256;i++)
		{
			short pixelvalue=(short)(i*1.2);
			if(pixelvalue>255)
					pixelvalue=255;
			else
				if(pixelvalue<0)
						pixelvalue=0;
			brighten[i]=pixelvalue;
		}
		LUT=new ShortLookupTable(0,brighten);
	}

	public void contrastDecLUT()
	{
		short brighten[]=new short[256];
		for(int i=0;i<256;i++)
		{
			short pixelvalue=(short)(i/1.2);
			if(pixelvalue>255)
				pixelvalue=255;
			else
				if(pixelvalue<0)
					pixelvalue=0;
			brighten[i]=pixelvalue;
		}
		LUT=new ShortLookupTable(0,brighten);
	}

	public void reverseLUT()
	{
		byte reverse[]=new byte[256];
		for(int i=0;i<256;i++)
			reverse[i]=(byte)(255-i);
		LUT=new ByteLookupTable(0,reverse);
	}

	public void reset()
	{
		big.setColor(Color.white);
		big.clearRect(0,0,bi.getWidth(this),bi.getHeight(this));
		big.drawImage(displayImage,0,0,this);
	}

	public void applyFilter()
	{
		LookupOp lop=new LookupOp(LUT,null);
		lop.filter(bi,bi);
	}

	public void grayOut()
	{
		ColorConvertOp colorConvert=new ColorConvertOp(
		ColorSpace.getInstance(ColorSpace.CS_GRAY),null);
		colorConvert.filter(bi,bi);
	}

	public void sharpen()
	{
			float data[]=
						{
							-1.0f,-1.0f,-1.0f,
							-1.0f,9.0f,-1.0f,
							-1.0f,-1.0f,-1.0f
						};

			Kernel kernel=new Kernel(3,3,data);
			ConvolveOp convolve=new ConvolveOp(kernel,ConvolveOp.EDGE_NO_OP,null);
			convolve.filter(biSrc,biDest);
			bi=biDest;
	}

	public void blur()
	{
			float data[]=
						{
							0.0625f,0.125f,0.0625f,
							0.125f,0.25f,0.125f,
							0.0625f,0.125f,0.0625f
						};
			Kernel kernel=new Kernel(3,3,data);
			ConvolveOp convolve=new ConvolveOp(kernel,ConvolveOp.EDGE_NO_OP,null);
			convolve.filter(biSrc,biDest);
			bi=biDest;
	}

	public void edgeDetect()
	{
		float data[]=
					{
						1.0f,0.0f,-1.0f,
						1.0f,0.0f,-1.0f,
						1.0f,0.0f,-1.0f
					};
		Kernel kernel=new Kernel(3,3,data);
		ConvolveOp convolve=new ConvolveOp(kernel,ConvolveOp.EDGE_NO_OP,null);
		convolve.filter(biSrc,biDest);
		bi=biDest;
	}


	public void Creset()
	{
		/*bi=biOrig;
		repaint();
		zoom = 0;*/
		//buffered=true;
		big.setColor(Color.white);
		big.clearRect(0,0,bi.getWidth(this),bi.getHeight(this));
		big.drawImage(displayImage,0,0,this);
		bi=biSrc;
	}

	public void bandCombine(float[][] bandCombineMatrix)
	{
		BandCombineOp bandCombineOp=new BandCombineOp (bandCombineMatrix,null);
		bandCombineOp.filter(srcRaster,dstRaster);
		bi=biDest;
		//displayImage = biDest;
	}

	public void applyValue(boolean scale,boolean shear)
	{
		if(scale)
		{
				transform.setToScale(scalex,scaley);
				scale=false;
		}
		else if (shear)
		{
			transform.setToShear(shearx,sheary);
			shear=false;
		}
	}

	public void affineApplyFilter()
	{
		AffineTransformOp op=new AffineTransformOp(transform,null);
		Graphics2D biDestG2D=biDest.createGraphics();
		biDestG2D.clearRect(0,0,biDest.getWidth(this),biDest.getHeight(this));
		op.filter(biSrc,biDest);
		bi=biDest;
	}

	/*public void getOrig()
	{
		bi=biOrig;
		repaint();
		buffered=true;
	}*/

	public void init()
	{
		Dimension d=getSize();
		int w=d.width;
		int h=d.height;
		int pixels[]=new int[w*h];
		int i=0;

		for(int y=0;y<h;y++)
		{
			for(int x=0;x<w;x++)
			{
				int r=(x^y)&0xff;
				int g=(x*2^y*2)&0xff;
				int b=(x*4^y*4)&0xff;
				pixels[i++]=(255<<24) | (r<<16) | (g<<8) | b;
			}
		}
		displayImage=createImage(new MemoryImageSource(w,h,pixels,0,w));
		bi1=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		big=bi1.createGraphics();
		big.drawImage(displayImage,0,0,this);
		bi=bi1;
		biSrc=bi1;
		biDest=new BufferedImage(displayImage.getWidth(this),displayImage.getHeight(this),BufferedImage.TYPE_INT_RGB);
		srcRaster=biSrc.getRaster();
		dstRaster=(WritableRaster)biDest.getRaster();
		biOrig=bi;
		repaint();
	}

	public void tileInit()
	{
		cell=new Image[4*4];
		try
		{
			CropImageFilter f;
			FilteredImageSource fis;
			for(int y=0;y<4;y++)
			{
				for(int x=0;x<4;x++)
				{
					f=new CropImageFilter(tw*x,th*y,tw,th);
					fis=new FilteredImageSource(displayImage.getSource(),f);
					int i=y*4+x;
					cell[i]=createImage(fis);
					mt.addImage(cell[i],i);
				}
			}
			mt.waitForAll();
			for(int i=0;i<32;i++)
			{
				int si=(int)(Math.random()*16);
				int di=(int)(Math.random()*16);
				Image tmp=cell[si];
				cell[si]=cell[di];
				cell[di]=tmp;
			}
			buffered=false;
		}
		catch (Exception e){};
	}
}
